<template>
    <div v-if="entry">
        <form @submit.prevent="update">
            <div class="box">
                <label>
                    Check in: <br>
                    <input class="input" type="text" value="entry.check_in" v-model="entry.check_in">
                </label>

                <label>
                    Check out: <br>
                    <input class="input" type="text" value="entry.check_out" v-model="entry.check_out">
                </label>
            </div>

            <input class="button is-link" type="submit" value="Edit Entry">
        </form>
    </div>
</template>

<script>
    import validate from 'validate.js';
    import axios from 'axios';

    export default {
        name: 'entries-view',
        created() {
            axios.get(`/api/users/${this.currentUser.name}/entries/${this.$route.params.id}`, {
                headers: {
                    "Authorization": `Bearer ${this.currentUser.token}`
                }
            })
            .then((res) => {
                this.entry = res.data.entry;
            })
        },
        data() {
            return {
                entry: null
            }
        },
        computed: {
            currentUser() {
                return this.$store.getters.currentUser;
            }
        },
        methods: {
            update() {
                const constrains = this.getContrains();

                const errors = validate(this.$data.entry);

                if(errors) {
                    return;
                }

                axios.patch(`/api/users/${this.currentUser.name}/entries/${this.$route.params.id}`, this.$data.entry, {
                    headers: {
                        "Authorization": `Bearer ${this.currentUser.token}`
                    }
                })
                .then((res) => {
                    this.$router.push('/entries');
                });
            },
            getContrains() {
                return {
                    check_in: {
                        presense: true
                    },
                    check_out: {
                        presense: true
                    }
                }
            }
        }
    }
</script>